//
//  $Id: Main.m,v 1.3 2008/04/24 08:09:37 rh Exp $
//  A simple test for a simple List class implementation
//
//  Copyright 2006-2008 Rene Hexel. All rights reserved.
//
#import <Foundation/Foundation.h>
#import "SimpleList.h"

void print_list(SimpleList *list)
{
	int count = 0;
	ListEnumerator *e = [list objectEnumerator];
	NSString *s;

	printf("List contains: (  ");
	while ((s = [[e nextObject] description]) != nil)
	{
		count++;
		printf("'%s'  ", [s cString]);
	}
	printf(") = %d object%s\n", count, count == 1 ? "" : "s");
}


int main (int argc, const char *argv[])
{
	NSAutoreleasePool *pool = [NSAutoreleasePool new];
	SimpleList *list = [[SimpleList alloc] initWithObjects:
		@"One", @"Two", @"Three", @"Four", @"Five", nil];

	print_list(list);

	[list addObject: @"Six"];	// add another object

	print_list(list);
	
	while ([[[list objectEnumerator] advance] removeObject])
		print_list(list);

	[list release];
	[pool release];
	return 0;
}
