//
//  $Id: SimpleList.h,v 1.1 2006/03/17 07:25:10 rh Exp $
//  An Example List Class
//
//  Created by Rene Hexel on 17/03/06.
//  Copyright 2006 Rene Hexel. All rights reserved.
//

#import <Foundation/Foundation.h>

@class ListEnumerator;	// forward reference for List

/*
 * A simple list class
 */
@interface SimpleList: NSObject
{
	id head;	// first node in the list
	id tail;	// last node in the list
}

- initWithObjects: (id) first, ...;

- addObject: (id) obj;	// add an object

- (ListEnumerator *) objectEnumerator;	// return an enumerator

- (void) dealloc;	// release all objects and free memory

// access methods

- head;
- tail;
- setHead: (id) newHead;
- setTail: (id) newHead;

@end


/*
 * An object enumerator for the above list class
 */

@interface ListEnumerator: NSEnumerator
{
	SimpleList *list;	// the list to enumerate
	id currentNode;		// the current node and
	id nextNode;		// the next node
}

- nextObject;			// the standard enumerator method

- initWithList: (SimpleList *) list;	// initialise for a specific list
- setList: (SimpleList *) newList;	// set a new list

- removeObject;			// remove (and return) the current object
- advance;			// advance to next object

- (void) dealloc;		// release list
@end
